include \masm32\include\masm32rt.inc
include \masm32\macros\timers.asm

.686
.mmx

pbin2	PROTO: DWORD, :DWORD

ResultsCorrect	= 0	; if 1, displays some results
Show_a_box	= 0	; if 1, displays a box showing plain and formatted BIN$
Use_dw2bin_ex	= 0	; if 1, uses old lib - size will increase by >2k
Use_d2b2	= 0	; if 1, uses old slow Dword2Bin2

MinLampSize	= 200	; "default size" in case of external APIs, e.g. crt_strstr

LAMP$ MACRO cycles:REQ, csize:REQ	; Usage: print LAMP$(cycles, size), " LAMPs", 13, 10
	ffree ST(7)			;; free the stack for pushing
	mov eax, csize
	.if eax==0
		add eax, MinLampSize
	.endif
	push eax
	fild dword ptr [esp]		;; move into ST (0)
	pop eax
	fsqrt
	push cycles
	fild dword ptr [esp]		;; push cycles on FPU
	fmul ST, ST(1)		;; multiply with sqrt(size)
	fistp dword ptr [esp]
	pop eax
	invoke dwtoa, eax, addr LampsBuffer
EXITM <offset LampsBuffer>
ENDM

BIN$ MACRO dwArg:REQ, tgt:=<0>
  cc INSTR <dwArg>, <eax>	;; to avoid a mov eax, eax
  if cc eq 0
	mov eax, dwArg			;; eax passes value to translate
  endif
  if @SizeStr(tgt) gt 1
	mov edx, tgt			;; dest buffer - if 0, use Dw2BinBuffer
  else
	mov edx, offset Dw2BinBuffer
  endif
  call Dword2Bin
  cc INSTR <tgt>, <f>	;; to avoid a mov eax, eax
  if cc
	if @SizeStr(tgt) eq 1
		mov al, 13
		mov 32[edx], al
	endif
  endif
  EXITM <edx>
ENDM

.data?
LampsBuffer	dd 4 dup (?)

Dw2BinBuffer	dd (36+32)/4 dup (?)	; 32 are needed, we pad 4 for alignment
Dw2BinTable	dd 2048/4 dup (?)	; old bintable

align 16
bt4	dd 2048/4 dup (?)	; reserve space for the new bintable

; code speed:
cy1	dd ?	; dw2bin_ex 
cy2	dd ?	; BIN$
cy3	dd ?	; Dword2Bin2
cy4	dd ?	; pbin
cy5	dd ?	; pbin2
cy6	dd ?	; nwDw2Bin
cy7	dd ?	; nwDw2BinJJ
cy8	dd ?	; NightWare
cy9	dd ?	; Lingo
cy10	dd ?	; Drizz
cy11	dd ?	; mmx qWord

; code size:
cs1	dd ?	
cs2	dd ?
cs3	dd ?
cs4	dd ?
cs5	dd ?
cs6	dd ?
cs7	dd ?
cs8	dd ?
cs9	dd ?
cs10	dd ?
cs11	dd ?

.data
BinaryTable	DWORD "0000","1000","0100","1100","0010","1010","0110","1110"
	DWORD "0001","1001","0101","1101","0011","1011","0111","1111"
.code
start:
	if Show_a_box
		invoke MessageBox, 0, BIN$(10011001100110011001100110011001b),
		chr$("BIN$ plain:"), MB_OK
		invoke MessageBox, 0, BIN$(10011001100110011001100110011001b, f),
		chr$("BIN$ formatted:"), MB_OK
	endif

	if ResultsCorrect
		call AreResultsCorrect
	endif
	call CalcSizes

	invoke Sleep, 500
	NumLoops = 10000000

	LOOP_COUNT EQU NumLoops
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		if 0	; the long and windy road
			mov edx, offset Dw2BinBuffer
			mov eax, 11111000001111100000111111110000b
			call Dword2Bin
			mov edx, offset Dw2BinBuffer
			mov eax, 00001111100000111110000011111111b
			call Dword2Bin
		else
			mov edx, BIN$(11111000001111100000111111110000b)
			mov edx, BIN$(00001111100000111110000011111111b)
		endif
	counter_end

	mov cy2, eax
	print str$(eax)," cycles timing BIN$     ", 9, " "
	print str$(cs2), " bytes",9
	print LAMP$(cy2, cs2), " LAMPs", 13, 10

	LOOP_COUNT EQU NumLoops
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke pbin2, 11111000001111100000111111110000b, ADDR Dw2BinBuffer
		invoke pbin2, 00001111100000111110000011111111b, ADDR Dw2BinBuffer
	counter_end
	mov cy5, eax

	print str$(eax)," cycles timing pbin2     ", 9, " "
	print str$(cs5), " bytes",9
	print LAMP$(cy5, cs5), " LAMPs", 13, 10

	LOOP_COUNT EQU NumLoops
; mov eax,valeur
; mov esi,String address
; call nwDw2Bin
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push esi
		mov eax, 11111000001111100000111111110000b
		mov esi, offset Dw2BinBuffer
		call nwDw2Bin
		mov eax, 00001111100000111110000011111111b
		mov esi, offset Dw2BinBuffer
		call nwDw2Bin
		pop esi
	counter_end
	mov cy6, eax

	print str$(eax)," cycles timing nwDw2Bin", 9, " "
	print str$(cs6), " bytes", 9
	print LAMP$(cy6, cs6), " LAMPs", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push esi
		mov eax, 11111000001111100000111111110000b
		mov esi, offset Dw2BinBuffer
		call nwDw2BinJJ
		mov eax, 00001111100000111110000011111111b
		mov esi, offset Dw2BinBuffer
		call nwDw2BinJJ
		pop esi
	counter_end
	mov cy7, eax

	print str$(eax)," cycles timing nwDw2BinJJ", 9, " "
	print str$(cs7), " bytes", 9
	print LAMP$(cy7, cs7), " LAMPs", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov eax, 11111000001111100000111111110000b
		mov edx, offset Dw2BinBuffer
		call NightWare
		mov eax, 00001111100000111110000011111111b
		mov edx, offset Dw2BinBuffer
		call NightWare
	counter_end
	mov cy8, eax

	print str$(eax)," cycles timing NightWare", 9, " "
	print str$(cs8), " bytes", 9
	print LAMP$(cy8, cs8), " LAMPs", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov eax, 11111000001111100000111111110000b
		mov edx, offset Dw2BinBuffer
		call BinLingo
		mov eax, 00001111100000111110000011111111b
		mov edx, offset Dw2BinBuffer
		call BinLingo
	counter_end
	mov cy9, eax

	print str$(eax)," cycles timing BinLingo", 9, " "
	print str$(cs9), " bytes", 9
	print LAMP$(cy9, cs9), " LAMPs", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov eax, 11111000001111100000111111110000b
		mov edx, offset Dw2BinBuffer
		call b2aDrizzAt
		mov eax, 00001111100000111110000011111111b
		mov edx, offset Dw2BinBuffer
		call b2aDrizzAt
	counter_end
	mov cy10, eax
	print str$(eax)," cycles timing b2aDrizzAt", 9, " "
	print str$(cs10), " bytes", 9
	print LAMP$(cy10, cs10), " LAMPs", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov ecx, 11111000001111100000111111110000b
		mov edx, offset Dw2BinBuffer
	; inc ecx
		call mmx_dw2bin
		mov ecx, 00001111100000111110000011111111b
		mov edx, offset Dw2BinBuffer
	; inc ecx
		call mmx_dw2bin
	counter_end
	mov cy11, eax
	print str$(eax)," cycles timing mmx_dw2bin", 9, " "
	print str$(cs11), " bytes", 9
	EMMS
	print LAMP$(cy11, cs11), " LAMPs", 13, 10

	if Use_dw2bin_ex
	LOOP_COUNT EQU NumLoops
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke dw2bin_ex, 11111000001111100000111111110000b, ADDR Dw2BinBuffer
		invoke dw2bin_ex, 00001111100000111110000011111111b, ADDR Dw2BinBuffer
	counter_end
	mov cy1, eax
	mov cs1, 2140	; can't calculate this one automatically
	print str$(eax)," cycles timing dw2bin_ex", 9, " 2140 bytes", 9	; 92+2048
	print LAMP$(cy1, cs1), " LAMPs", 13, 10
	endif

	if Use_d2b2
		LOOP_COUNT EQU NumLoops
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			mov eax, 11111000001111100000111111110000b
			call Dword2Bin2
			mov eax, 00001111100000111110000011111111b
			call Dword2Bin2
		counter_end
		mov cy3, eax
		print str$(eax)," cycles timing Dword2Bin2", 9, " ",
		print str$(cs3), " bytes ",9
		print LAMP$(cy3, cs3), " LAMPs"
	endif

	print chr$(13, 10, 10), "LAMPs = Lean And Mean Points = cycles * sqrt(size)", 13,10

	getkey
	invoke ExitProcess, 0

align 16
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

Dword2Bin proc	; ->BIN$: JJ - credits to Sinsi of the Masm32 Forum
  push ebx
  push esi
  push edi

  mov edi, offset Dw2BinTable		; old \masm32\m32lib\bintbl.asm
  mov ecx, [edi]
  .if ecx==0			; it seems you have to initialise your bintable...
	push eax		; save value
	push edx		; save destination
	mov edx, offset Dw2BinTable+2048	; destination bintable
	mov esi, 63							; outer loop counter
	mov edi, 0FCFDFEFFh				; seed for creating table
btInit:
	mov eax, edi
	sub edi, 04040404h
	mov ecx, 31		; inner loop counter

@@:	xor ebx, ebx
	dec edx			; on exit, edx will point to the string
	sar eax, 1		; we work from right to left
	adc ebx, 48		; +48: Ascii 0 or, with carry, +49 : Ascii 1
	mov [edx], bl
	dec ecx			; decrement inner counter
	jge @B			; dec sets only the sign flag

	dec esi			; decrement outer counter
	jge btInit		; dec sets only the sign flag
	if 1	; allows BIN$(123,f)
	mov edi, offset Dw2BinBuffer+35
	mov eax, 808520970	; 13, 10, "10"
	mov [edi-4], eax
	mov ebx, 4
oLp:	mov eax, "9"
	mov ecx, 9
	dec ebx
	jz OK
iLp:	stosb
	dec eax
	cmp eax, "0"
	jge iLp
	dec ecx
	jnz oLp
	endif
OK:	mov edi, edx
	pop edx			; get destination
	pop eax			; get value
  .endif

  movzx ecx,  al	; the value to translate
  mov ebx, [edi+ecx*8]
  mov esi, [edi+ecx*8+4]
  mov 24[edx], ebx
  mov 28[edx], esi

  movzx ecx,  ah
  mov ebx, [edi+ecx*8]
  mov esi, [edi+ecx*8+4]
  shr eax, 16
  mov 16[edx], ebx
  mov 20[edx], esi

  movzx ecx,  al
  mov ebx, [edi+ecx*8]
  mov esi, [edi+ecx*8+4]
  mov 8[edx], ebx
  mov 12[edx], esi

  movzx ecx,  ah
  mov ebx, [edi+ecx*8]
  mov esi, [edi+ecx*8+4]
  mov [edx], ebx
  mov 4[edx], esi
  mov 32[edx], ch	; null terminator not really needed, always 32 bytes
  pop edi
  pop esi
  pop ebx

  ret	; not: 8 
Dword2Bin endp
gL2:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef 

align 4
gStart3:
Dword2Bin2 proc uses ebx
	mov edx, offset Dw2BinBuffer
	xor ecx, ecx
	mov [edx+32], cl	; null terminator
	add ecx, 7	; 31

	; 4* setc bl plus add ebx, 30303030h is a lot slower
	; nop

@@:	sub ebx, ebx	; 2 cycle
	; ## this nop looks superfluous but leads to a decrease of up to 78 cycles ...!
	nop
	sar eax, 1		; 2 cycles - we read from left to right
	adc ebx, 48	; 1 +48: Ascii 0 or, with carry, +49 : Ascii 1

	sal ebx, 8		; 2 cycles - we write from right to left
	sar eax, 1		; 2 cycles - we read from left to right
	adc ebx, 48	; 1 +48: Ascii 0 or, with carry, +49 : Ascii 1

	sal ebx, 8		; 2 cycles - we write from right to left
	sar eax, 1		; 2 cycles - we read from left to right
	adc ebx, 48	; 1 +48: Ascii 0 or, with carry, +49 : Ascii 1

	sal ebx, 8		; 2 cycles - we write from right to left
	sar eax, 1		; 2 cycles - we read from left to right
	adc ebx, 48	; 1 +48: Ascii 0 or, with carry, +49 : Ascii 1

	mov [edx+4*ecx], ebx
	dec ecx		; 1 decrement counter
	; sub ecx, 1	; 1 but in practice 9 cycles slower
	jge @B		; dec sets only the sign flag
	ret
Dword2Bin2 endp
gL3:

align 4
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

pbin PROC PUBLIC num:DWORD,buf:DWORD
    push ebx
    push esi
    push edi
 
    mov edi, offset bt4	; old bintable
    mov eax, [edi]
    .if eax==0	; seems you have to initialise your bintable...

	mov edx, offset bt4+2048	; destination bintable
	mov esi, 63	; outer loop counter
	mov edi, 0FCFDFEFFh
btInit:
	mov eax, edi
	sub edi, 04040404h
	mov ecx, 31	; inner loop counter

@@:	xor ebx, ebx
	dec edx		; on exit, edx will point to the string
	sar eax, 1	; we work from right to left
	adc ebx, 48	; +48: Ascii 0 or, with carry, +49 : Ascii 1
	mov [edx], bl
	dec ecx		; decrement inner counter
	jge @B		; dec sets only the sign flag

	dec esi		; decrement outer counter
	jge btInit	; dec sets only the sign flag
	mov edi, edx

    .endif

    mov ecx,16[esp]
    mov edx,20[esp]

    movzx eax,cl
    mov ebx,[edi+eax*8]
    mov esi,[edi+eax*8+4]
    mov 24[edx],ebx
    mov 28[edx],esi

    movzx eax,ch
    mov ebx,[edi+eax*8]
    mov esi,[edi+eax*8+4]
    shr ecx,16
    mov 16[edx],ebx
    mov 20[edx],esi

    movzx eax,cl
    mov ebx,[edi+eax*8]
    mov esi,[edi+eax*8+4]
    mov 8[edx],ebx
    mov 12[edx],esi

    movzx eax,ch
    mov ebx,[edi+eax*8]
    mov esi,[edi+eax*8+4]
    sub eax, eax
    mov [edx],ebx
    mov 4[edx],esi

    mov 32[edx],al

    pop edi
    pop esi
    pop ebx
    ret 8
pbin ENDP
gL4:

pbin2 PROC PUBLIC num:DWORD,buf:DWORD
    push ebx
    push esi
    push edi
 
    mov edi, offset bt4	; old bintable
    mov eax, [edi]
    .if eax==0	; seems you have to initialise your bintable...

	mov edx, offset bt4+2048	; destination bintable
	mov esi, 63	; outer loop counter
	mov edi, 0FCFDFEFFh
btInit:
	mov eax, edi
	sub edi, 04040404h
	mov ecx, 31	; inner loop counter

@@:	xor ebx, ebx
	dec edx		; on exit, edx will point to the string
	sar eax, 1	; we work from right to left
	adc ebx, 48	; +48: Ascii 0 or, with carry, +49 : Ascii 1
	mov [edx], bl
	dec ecx		; decrement inner counter
	jge @B		; dec sets only the sign flag

	dec esi		; decrement outer counter
	jge btInit	; dec sets only the sign flag
	mov edi, edx

    .endif

    mov edx, 20[esp]

if 1	; pBin2
	mov eax, 16[esp]
    movzx ecx, al	;cl
    mov ebx,[edi+ecx*8]
    mov esi,[edi+ecx*8+4]
    mov 24[edx],ebx
    mov 28[edx],esi

    movzx ecx, ah	;ch
    mov ebx,[edi+ecx*8]
    mov esi,[edi+ecx*8+4]
    shr eax,16
    mov 16[edx],ebx
    mov 20[edx],esi

    movzx ecx, al	;cl
    mov ebx,[edi+ecx*8]
    mov esi,[edi+ecx*8+4]
    mov 8[edx],ebx
    mov 12[edx],esi

    movzx ecx, ah	;ch
    mov ebx, [edi+ecx*8]
    mov esi, [edi+ecx*8+4]
    mov [edx], ebx
    mov 4[edx], esi
    mov 32[edx], ch	; al
else
    mov ecx,16[esp]
    movzx eax,cl
    mov ebx,[edi+eax*8]
    mov esi,[edi+eax*8+4]
    mov 24[edx],ebx
    mov 28[edx],esi

    movzx eax,ch
    mov ebx,[edi+eax*8]
    mov esi,[edi+eax*8+4]
    shr ecx,16
    mov 16[edx],ebx
    mov 20[edx],esi

    movzx eax,cl
    mov ebx,[edi+eax*8]
    mov esi,[edi+eax*8+4]
    mov 8[edx],ebx
    mov 12[edx],esi

    movzx eax,ch
    mov ebx,[edi+eax*8]
    mov esi,[edi+eax*8+4]
    sub eax, eax
    mov [edx],ebx
    mov 4[edx],esi

    mov 32[edx],al
endif

    pop edi
    pop esi
    pop ebx
    ret 8
pbin2 ENDP
gL5:

nwDw2Bin PROC
	mov BYTE PTR [esi+32], 0
	mov ecx, 32	; 28 would produce garbage
Label1:
	mov edx, eax
	and edx, 00000000Fh
	shr eax, 4
	mov edx, DWORD PTR [BinaryTable+edx*4]
	sub ecx, DWORD
	mov DWORD PTR [esi+ecx], edx
	jnz Label1
ret
nwDw2Bin ENDP
gL6:

align 16
nwDw2BinJJ PROC
	mov BYTE PTR [esi+32], 0
	mov ecx, 28		 ; works
Label1:
	mov edx, eax
	and edx, 00000000Fh
	shr eax, 4
	mov edx, DWORD PTR [BinaryTable+edx*4]
	sub ecx, DWORD
	; shr eax, 4 moved up to reduce stalls
	mov DWORD PTR [esi+ecx+4], edx	; +4 is one byte longer but faster
	; sub ecx, DWORD moved up to reduce stalls
	jnz Label1	; jns Label1
ret
nwDw2BinJJ ENDP
gL7:

  ; ---------------------------------------------
  ; Modified NightWare's DWORD to bin string algo (Hutch)
  ; ---------------------------------------------
align 16
NightWare PROC

;.data
;BinaryTable	DWORD "0000","1000","0100","1100","0010","1010","0110","1110"
;	DWORD "0001","1001","0101","1101","0011","1011","0111","1111"
;.code

; mov ecx,value
; mov edx,buffer
; no need to pudh/pop esi/edi

  mov BYTE PTR [edx+32],0

mov eax,ecx
and eax,00000000Fh
shr ecx,2
mov eax,DWORD PTR [BinaryTable+eax*4]
mov DWORD PTR [edx+28],eax

mov eax,ecx
and eax,00000003Ch ; 0Fh * 4
shr ecx,4
mov eax,DWORD PTR [BinaryTable+eax]
mov DWORD PTR [edx+24],eax

mov eax,ecx
and eax,00000003Ch
shr ecx,4
mov eax,DWORD PTR [BinaryTable+eax]
mov DWORD PTR [edx+20],eax

mov eax,ecx
and eax,00000003Ch
shr ecx,4
mov eax,DWORD PTR [BinaryTable+eax]
mov DWORD PTR [edx+16],eax

mov eax,ecx
and eax,00000003Ch
shr ecx,4
mov eax,DWORD PTR [BinaryTable+eax]
mov DWORD PTR [edx+12],eax

mov eax,ecx
and eax,00000003Ch
shr ecx,4
mov eax,DWORD PTR [BinaryTable+eax]
mov DWORD PTR [edx+8],eax

mov eax,ecx
and eax,00000003Ch
shr ecx,4
mov eax,DWORD PTR [BinaryTable+eax]
mov DWORD PTR [edx+4],eax

and ecx,00000003Ch
mov ecx,DWORD PTR [BinaryTable+ecx]
mov DWORD PTR [edx],ecx

;    pop edi
;    pop esi

    ret ;;; 8

NightWare ENDP
gL8:

align 16
BinLingo proc
mov   eax, esp
lea   esp, [edx+32]
mov   BYTE PTR [edx+32],0
mov   edx, eax

shld  eax, ecx, 30
and   ecx, 00000000Fh
push  DWORD PTR [BinaryTable+ecx*4]

shld  ecx, eax, 28
and   eax, 00000003Ch
push  DWORD PTR [BinaryTable+eax]
shld  eax, ecx, 28

and   ecx, 3Ch
push  DWORD PTR [BinaryTable+ecx]

mov   ecx, eax
and   eax, 3Ch
push  DWORD PTR [BinaryTable+eax]
shr   ecx, 4

mov   eax, ecx
and   ecx, 3Ch
push  DWORD PTR [BinaryTable+ecx]
shr   eax, 4

mov   ecx, eax
and   eax, 3Ch
push  DWORD PTR [BinaryTable+eax]
shr   ecx, 4

mov   eax, ecx
and   ecx, 3Ch
push  DWORD PTR [BinaryTable+ecx]
shr   eax, 4

and   eax, 3Ch
push  DWORD PTR [BinaryTable+eax]
mov   esp, edx
ret
BinLingo ENDP
gL9:

bintab equ BinaryTable
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
b2aDrizzAt proc ; dwValue:dword,pBuffer:dword
;mov eax,[esp+4];dwValue
;mov edx,[esp+8];pBuffer
push edi
push esi
push ebx
mov ebx,1111b
mov ecx,11110000b
mov edi,111100000000b
mov esi,1111000000000000b
and ecx,eax
and edi,eax
shr ecx,4
and esi,eax
shr edi,8
and ebx,eax
shr esi,12
mov ebx,[ebx*4+bintab]
mov ecx,[ecx*4+bintab]
mov edi,[edi*4+bintab]
mov esi,[esi*4+bintab]
shr eax,16
mov [edx+7*4],ebx
mov [edx+6*4],ecx
mov [edx+5*4],edi
mov [edx+4*4],esi
mov ebx,1111b
mov ecx,11110000b
mov edi,111100000000b
mov esi,1111000000000000b
and ecx,eax
and edi,eax
shr ecx,4
and esi,eax
shr edi,8
and ebx,eax
shr esi,12
mov ebx,[ebx*4+bintab]
mov ecx,[ecx*4+bintab]
mov edi,[edi*4+bintab]
mov esi,[esi*4+bintab]
mov [edx+3*4],ebx
mov [edx+2*4],ecx
mov [edx+1*4],edi
mov [edx+0*4],esi
mov byte ptr [edx+32],0
pop ebx
pop esi
pop edi
ret ; 2*4
b2aDrizzAt endp
gL10:

;OPTION PROLOGUE:PROLOGUEDEF
;OPTION EPILOGUE:EPILOGUEDEF
;and here's my regular function
;Code:
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
;returns size in eax

b2aDrizzRf proc dwValue:dword,pBuffer:dword;buff max 33bytes
push edi
mov ecx,31
mov edx,[esp+4][4];dwValue
mov edi,[esp+8][4];pBuffer
bsr eax,edx
jz @2
sub ecx,eax
shl edx,cl
mov ecx,eax
@1: add edx,edx
inc edi
mov al,'0' shr 1
adc al,al
dec ecx
mov [edi-1],al
jns @1
mov [edi],dl
mov eax,edi
pop edi
sub eax,[esp+8];pBuffer
ret 2*4
@2: mov word ptr [edi],'0'
mov eax,1
pop edi
ret 2*4
b2aDrizzRf endp

align 16

mmx_dw2bin proc ;var:DWORD,buffer:DWORD
   ;var in ecx or eax?
   ;buffer in edx

    .data
	bitmsk	db 128, 64, 32, 16, 8, 4, 2, 1
	ascmsk	db 8 dup (031h)
    .code

if 1	; new Drizz variant, mmx only
 movq mm6,QWORD ptr [bitmsk]
movq mm7,QWORD ptr [ascmsk]
pxor mm5,mm5
movd mm0,eax
punpcklbw mm0,mm0
punpcklwd mm1,mm0
movq mm2,mm0
punpckhwd mm3,mm0
punpcklwd mm0,mm0
punpckhwd mm1,mm1
punpckhwd mm2,mm2
punpckhwd mm3,mm3
punpckldq mm0,mm0
punpckhdq mm1,mm1
punpckldq mm2,mm2
punpckhdq mm3,mm3
pand mm0,mm6
pand mm1,mm6
pand mm2,mm6
pand mm3,mm6
pcmpeqb mm0,mm5
pcmpeqb mm1,mm5
pcmpeqb mm2,mm5
pcmpeqb mm3,mm5
paddb mm0,mm7
paddb mm1,mm7
paddb mm2,mm7
paddb mm3,mm7
movq [edx+24],mm0
movq [edx+16],mm1
movq [edx+8],mm2
movq [edx],mm3
mov BYTE ptr [edx+32],0

else

    bswap eax
    movq mm6,QWORD ptr [bitmsk]
    movq mm7,QWORD ptr [ascmsk]
    pxor mm5,mm5

    movd mm0,eax
    punpcklbw mm0,mm0

    movq mm1,mm0
    pshufw mm1,mm0,0
    pand mm1,mm6
    pcmpeqb mm1,mm5
    paddsb mm1,mm7
    movq QWORD ptr [edx],mm1

    movq mm2,mm0
    pshufw mm2,mm0,001010101y
    pand mm2,mm6
    pcmpeqb mm2,mm5
    paddsb mm2,mm7
    movq QWORD ptr [edx+8],mm2

    movq mm1,mm0
    pshufw mm1,mm0,010101010y
    pand mm1,mm6
    pcmpeqb mm1,mm5
    paddsb mm1,mm7
    movq QWORD ptr [edx+16],mm1

    movq mm2,mm0
    pshufw mm2,mm0,011111111y
    pand mm2,mm6
    pcmpeqb mm2,mm5
    paddsb mm2,mm7
    movq QWORD ptr [edx+24],mm2

    mov BYTE ptr [edx+32], 0
endif
    ret
mmx_dw2bin endp

gL11:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef 

AreResultsCorrect proc
	print chr$("Testing correctness of results for BIN$, pbin2, nwDw2Bin and mmx_qWord", 13, 10)
	push ebx
	mov eax, 11110111000000001111111100000000b
	mov ebx, eax
;	print "BIN$", 9
;	mov eax, ebx
	print BIN$(eax)
	print chr$(9, "BIN$", 13, 10)
	invoke pbin2, ebx, ADDR Dw2BinBuffer
	print addr Dw2BinBuffer
	print chr$(9, "pbin2", 13, 10)
		push esi
		mov esi, offset Dw2BinBuffer
		mov eax, ebx
		call nwDw2BinJJ
		print addr Dw2BinBuffer
		print chr$(9, "nwDw2Bin")
		print chr$(13, 10)
		mov eax, ebx
		call nwDw2Bin
		print addr Dw2BinBuffer
		print chr$(9, "nwDw2BinJJ")
		print chr$(13, 10)
		mov eax, ebx
		mov edx, esi
		call mmx_dw2bin
		print addr Dw2BinBuffer
		print chr$(9, "mmx_dw2bin")
		pop esi
	print chr$(13, 10, "11110111000000001111111100000000", 9, "original value", 13, 10, 10)

	mov eax, 00001000111111110000000011111111b
	mov ebx, eax
	print BIN$(eax)
	print chr$(13, 10)
	invoke pbin2, ebx, ADDR Dw2BinBuffer
	print addr Dw2BinBuffer
	print chr$(13, 10)
		push esi
		mov esi, offset Dw2BinBuffer
		mov eax, ebx
		call nwDw2BinJJ
		print addr Dw2BinBuffer
		print chr$(9, "nwDw2Bin")
		print chr$(13, 10)
		mov eax, ebx
		call nwDw2Bin
		print addr Dw2BinBuffer
		print chr$(9, "nwDw2BinJJ")
		print chr$(13, 10)
		mov eax, ebx
		mov edx, esi
		call mmx_dw2bin
		print addr Dw2BinBuffer
		print chr$(9, "mmx_dw2bin")
		pop esi
	print chr$(13, 10, "00001000111111110000000011111111", 13, 10, 10)

	mov eax, 00100011111111000000001111111100b
	mov ebx, eax
	print BIN$(eax)
	print chr$(13, 10)
	invoke pbin2, ebx, ADDR Dw2BinBuffer
	print addr Dw2BinBuffer
	print chr$(13, 10)
		push esi
		mov esi, offset Dw2BinBuffer
		mov eax, ebx
		call nwDw2BinJJ
		print addr Dw2BinBuffer
		print chr$(9, "nwDw2Bin")
		print chr$(13, 10)
		mov eax, ebx
		call nwDw2Bin
		print addr Dw2BinBuffer
		print chr$(9, "nwDw2BinJJ")
		print chr$(13, 10)
		mov eax, ebx
		mov edx, esi
		call mmx_dw2bin
		print addr Dw2BinBuffer
		print chr$(9, "mmx_dw2bin")
		pop esi
	print chr$(13, 10, "00100011111111000000001111111100", 13, 10, 10)

	mov eax, 10101010101010101010101010101010b
	mov ebx, eax
	print BIN$(eax)
	print chr$(13, 10)
	invoke pbin2, ebx, ADDR Dw2BinBuffer
	print addr Dw2BinBuffer
	print chr$(13, 10)
		push esi
		mov esi, offset Dw2BinBuffer
		mov eax, ebx
		call nwDw2BinJJ
		print addr Dw2BinBuffer
		print chr$(9, "nwDw2Bin")
		print chr$(13, 10)
		mov eax, ebx
		call nwDw2Bin
		print addr Dw2BinBuffer
		print chr$(9, "nwDw2BinJJ")
		print chr$(13, 10)
		mov eax, ebx
		mov edx, esi
		call mmx_dw2bin
		print addr Dw2BinBuffer
		print chr$(9, "mmx_dw2bin")
		pop esi
	print chr$(13, 10, "10101010101010101010101010101010", 13, 10, 10)
	if 0
	invoke GetKeyState, VK_CAPITAL
	mov ebx, eax
	print BIN$(eax)
	print chr$(13, 10)
	invoke pbin2, ebx, ADDR Dw2BinBuffer
	print addr Dw2BinBuffer
	print chr$(13, 10)
		push esi
		mov esi, offset Dw2BinBuffer
		mov eax, ebx
		call nwDw2BinJJ
		print addr Dw2BinBuffer
		print chr$(9, "nwDw2Bin")
		print chr$(13, 10)
		mov eax, ebx
		call nwDw2Bin
		print addr Dw2BinBuffer
		print chr$(9, "nwDw2BinJJ")
		pop esi
	print chr$(13, 10, "GetKeyState (VK_CAPITAL), i.e. Caps Lock", 13, 10, 10, 10)
	endif
	pop ebx
	ret
AreResultsCorrect endp

CalcSizes proc
	mov ecx, offset gL2
	sub ecx, offset Dword2Bin	; aka BIN$ proc
	add ecx, 2
	mov cs2, ecx

	mov ecx, offset gL3
	sub ecx, offset Dword2Bin2
	add ecx, 2
	mov cs3, ecx

	mov ecx, offset gL4
	sub ecx, offset pbin
	add ecx, 4
	; no more add ecx, 2048 for old bintable
	mov cs4, ecx

	mov ecx, offset gL5
	sub ecx, offset pbin2
	add ecx, 4
	; no more add ecx, 2048 for old bintable
	mov cs5, ecx

	mov ecx, offset gL6
	sub ecx, offset nwDw2Bin
	add ecx, 4
	add ecx, 64				; BinaryTable 
	mov cs6, ecx

	mov ecx, offset gL7
	sub ecx, offset nwDw2BinJJ
	add ecx, 4
	add ecx, 64				; BinaryTable 
	mov cs7, ecx

	mov ecx, offset gL8
	sub ecx, offset NightWare
	add ecx, 4
	add ecx, 64				; BinaryTable 
	mov cs8, ecx

	mov ecx, offset gL9
	sub ecx, offset BinLingo
	add ecx, 4
	add ecx, 64				; BinaryTable
	mov cs9, ecx

	mov ecx, offset gL10
	sub ecx, offset b2aDrizzAt
	add ecx, 4
	add ecx, 64				; BinaryTable
	mov cs10, ecx

	mov ecx, offset gL11
	sub ecx, offset mmx_dw2bin
	add ecx, 4
	add ecx, 16				; bitmsk + ascmsk
	mov cs11, ecx

	ret
CalcSizes endp

end start

#########  Disassembly dw2bin_ex  #########

92 bytes plus 2048 bytes table

CPU Disasm
Address    Hex dump          Command                            Comments
00401340   $ 55             push ebp
00401341   . 8BEC           mov ebp, esp
00401343   . 53             push ebx
00401344   . BB B0304000    mov ebx, offset TestBits.004030B0  ; ASCII "000000000000000100000010000000110000010000000101000001100000011100001000000010010000101000001011000011000000110100001110000011110001000000010001000100100001001100010100000101010001011000010111000110000001100100011010000110110001110000011"...
00401349   . 33C0           xor eax, eax
0040134B   . 8B55 0C        mov edx, dword ptr [arg.2]         ; ASCII "00001111100000111110000011111111"
0040134E   . 8A45 0B        mov al, byte ptr [arg.1+3]
00401351   . 8B0CC3         mov ecx, dword ptr [eax*8+ebx]
00401354   . 890A           mov dword ptr [edx], ecx
00401356   . 8B4CC3 04      mov ecx, dword ptr [eax*8+ebx+4]
0040135A   . 894A 04        mov dword ptr [edx+4], ecx
0040135D   . 8A45 0A        mov al, byte ptr [arg.1+2]
00401360   . 8B0CC3         mov ecx, dword ptr [eax*8+ebx]
00401363   . 894A 08        mov dword ptr [edx+8], ecx
00401366   . 8B4CC3 04      mov ecx, dword ptr [eax*8+ebx+4]
0040136A   . 894A 0C        mov dword ptr [edx+0C], ecx
0040136D   . 8A45 09        mov al, byte ptr [arg.1+1]
00401370   . 8B0CC3         mov ecx, dword ptr [eax*8+ebx]
00401373   . 894A 10        mov dword ptr [edx+10], ecx
00401376   . 8B4CC3 04      mov ecx, dword ptr [eax*8+ebx+4]
0040137A   . 894A 14        mov dword ptr [edx+14], ecx
0040137D   . 8A45 08        mov al, byte ptr [arg.1]
00401380   . 8B0CC3         mov ecx, dword ptr [eax*8+ebx]
00401383   . 894A 18        mov dword ptr [edx+18], ecx
00401386   . 8B4CC3 04      mov ecx, dword ptr [eax*8+ebx+4]
0040138A   . 894A 1C        mov dword ptr [edx+1C], ecx
0040138D   . C642 20 00     mov byte ptr [edx+20], 0
00401391   . 5B             pop ebx
00401392   . C9             leave
00401393   . C2 0800        retn 8
00401396-00401340=92

LeanAndMeanPoints:
139 cycles timing dw2bin_ex	size 2140 bytes	139*sqrt(2140)=6384
462 cycles timing Dword2Bin	size 31 bytes	462*sqrt(31)=2572
335 cycles timing Dword2Bin2	size 57 bytes	335*sqrt(57)=2529

OPT_DelTmp	0


OLD Bintable
        db "00000000000000010000001000000011 00000100000001010000011000000111"
        db "0000100000001001000010100000101100001100000011010000111000001111"
        db "0001000000010001000100100001001100010100000101010001011000010111"
        db "0001100000011001000110100001101100011100000111010001111000011111"
        db "0010000000100001001000100010001100100100001001010010011000100111"
        db "0010100000101001001010100010101100101100001011010010111000101111"
        db "0011000000110001001100100011001100110100001101010011011000110111"
        db "0011100000111001001110100011101100111100001111010011111000111111"
        db "0100000001000001010000100100001101000100010001010100011001000111"
        db "0100100001001001010010100100101101001100010011010100111001001111"
        db "0101000001010001010100100101001101010100010101010101011001010111"
        db "0101100001011001010110100101101101011100010111010101111001011111"
        db "0110000001100001011000100110001101100100011001010110011001100111"
        db "0110100001101001011010100110101101101100011011010110111001101111"
        db "0111000001110001011100100111001101110100011101010111011001110111"
        db "0111100001111001011110100111101101111100011111010111111001111111"
        db "1000000010000001100000101000001110000100100001011000011010000111"
        db "1000100010001001100010101000101110001100100011011000111010001111"
        db "1001000010010001100100101001001110010100100101011001011010010111"
        db "1001100010011001100110101001101110011100100111011001111010011111"
        db "1010000010100001101000101010001110100100101001011010011010100111"
        db "1010100010101001101010101010101110101100101011011010111010101111"
        db "1011000010110001101100101011001110110100101101011011011010110111"
        db "1011100010111001101110101011101110111100101111011011111010111111"
        db "1100000011000001110000101100001111000100110001011100011011000111"
        db "1100100011001001110010101100101111001100110011011100111011001111"
        db "1101000011010001110100101101001111010100110101011101011011010111"
        db "1101100011011001110110101101101111011100110111011101111011011111"
        db "1110000011100001111000101110001111100100111001011110011011100111"
        db "1110100011101001111010101110101111101100111011011110111011101111"
        db "1111000011110001111100101111001111110100111101011111011011110111"
        db "11111000111110011111101011111011 11111100111111011111111011111111"
